<?php
/**
 * author Sergio Antonio Ochoa Martinez - gnu.java.sergio@gmail.com
 * Copyright (c) 2006-2012 Paco Avila & Josep Llort
 * WebSites: www.openkm.com
 * 
 * No bytes were intentionally harmed during the development of this application.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' ); 

jimport('joomla.application.component.view');

class OpenKMViewEscritorio extends JView {

    public function display($tpl = null) {
        $layout = JRequest::getVar('layout');
        $user = & JFactory::getUser();
        $app = JFactory::getApplication();
        $params = $app->getParams();
        $nameConfiguration = $params->get('nameConfiguration');
        require_once(JPATH_COMPONENT . DS . 'models' . DS . 'configuracion.php');
        $modelConfiguracion = new OpenKMModelConfiguracion();
        $rowsCongiguracion = $modelConfiguracion->getObject($nameConfiguration);
        $rowConfiguracion = $rowsCongiguracion[0];
        $url = $rowConfiguracion->url;
        $user = $rowConfiguracion->usuario;
        $password = $rowConfiguracion->password;
        $acceso = $rowConfiguracion->acceso;
        $okmPath = $rowConfiguracion->okmPath;
        $this->assignRef('rowConfiguracion', $rowConfiguracion);
        $error = 0;
        $entrar = 0;
        if ($layout == 'view') {
            if ($acceso == 'Private') {
                $entrar = JRequest::getVar("entrar");
                if ($entrar == null) {
                    $entrar = 0;
                }
            } else {
                $entrar = 1;
            }
            if ($entrar == 1) {
                try {
                    // Register WSDL
                    $OKMAuth = new SoapClient($url . '/services/OKMAuth?wsdl');

                    // Login
                    $loginResp = $OKMAuth->login(array('user' => $user, 'password' => $password));
                    $token = $loginResp->return;
                    $this->assignRef('token', $token);

                    // Register WSDL                    
                    $OKMAuth = new SoapClient($url . '/services/OKMAuth?wsdl');
                    $OKMDocument = new SoapClient($url . '/services/OKMDocument?wsdl');
                    $OKMFolder = new SoapClient($url . '/services/OKMFolder?wsdl');
                    $OKMMail = new SoapClient($url . '/services/OKMMail?wsdl');
                    $path = JRequest::getVar('path');
                    if ($path == '' || $path == $okmPath) {
                        $path = $okmPath;
                        $ruta = array();
                        $ruta[] = $path;
                        $session = JFactory::getSession();
                        $session->set('ruta', $ruta);
                    } else {
                        $valor = JRequest::getVar('v');
                        $session = JFactory::getSession();
                        $ruta = $session->get('ruta');
                        if ($valor != 1) {
                            $ruta[] = $path;
                            $session->set('ruta', $ruta);
                        } else {
                            $j = 0;
                            for ($i = 0; $i < count($ruta); $i++) {
                                if ($path == $ruta[$i]) {
                                    $j = $i;
                                }
                            }
                            for ($i = $j; $i < count($ruta); $i++) {
                                unset($ruta[$i]);
                            }
                            $session->set('ruta', $ruta);
                        }
                    }
                    $this->assignRef('OKMAuth', $OKMAuth);
                    $this->assignRef('OKMDocument', $OKMDocument);
                    $this->assignRef('OKMFolder', $OKMFolder);
                    $this->assignRef('OKMMail', $OKMMail);
                    $this->assignRef('path', $path);
                    $this->assignRef('error', $error);
                    $this->assignRef('session', $session);
                } catch (Exception $e) {
                    $error = 1;
                    $this->assignRef('error', $error);
                }
            }//fin if entrar
            $this->assignRef('mensaje', JRequest::getVar('mensaje'));
            $this->assignRef('entrar', $entrar);
        } else if ($layout == 'download') {
            try {
                $path = JRequest::getVar('path');
//                $path = '/okm:root/test1.docx';
                // Register WSDL
                $OKMAuth = new SoapClient($url . '/services/OKMAuth?wsdl');
                // Login
                $loginResp = $OKMAuth->login(array('user' => $user, 'password' => $password));
                $token = $loginResp->return;
                // Register WSDL
                $OKMDocument = new SoapClient($url . '/services/OKMDocument?wsdl');

                $getPropertiesResp = $OKMDocument->getProperties(array('token' => $token, 'docPath' => $path));
                $properties = $getPropertiesResp->return;

                $getContent = $OKMDocument->getContent(array('token' => $token, 'docPath' => $path, 'checkout' => false));
                $content = $getContent->return;
                $OKMAuth->logout(array('token' => $token));
                $this->assignRef('path', $path);
                $this->assignRef('properties', $properties);
                $this->assignRef('content', $content);
            } catch (Exception $e) {
                $error = 1;
            }
        }
        $this->assignRef('user', $user);
        parent::display($tpl);
    }

}

?>
